<?php if (!defined('BASE_DIR')) exit('No direct script access allowed');

/*
*	SNIPPET Albireo для підрахунку статистики відвідин сайту.
*	Статистика зберігається у файлі json, також призначається
*	cookie для зберігання в браузері до 00:00 наступної доби (UTC).
*/
?>

<?php
// Вказуємо шлях та назву файла для збереження даних лічильника
$dir_statistica		= 'uploads/statistica/';
$file_statistica	= 'statistica.json';
$statistica	= $dir_statistica.$file_statistica;

// Перевіряємо наявність каталогу
if (!file_exists($dir_statistica)) {
    mkdir($dir_statistica, 0755, true); // Створюємо каталог, якщо він не існує
}

/** 
 * Set cookie 
 * 
 * Accepts an arbitrary number of parameters (up to 7) or an associative 
 * array in the first parameter containing all the values. 
 * 
 * @param   string|mixed[]  $name       Cookie name or an array containing parameters 
 * @param   string      $value      Cookie value 
 * @param   int     $expire     Cookie expiration time in seconds 
 * @param   string      $domain     Cookie domain (e.g.: '.yourdomain.com') 
 * @param   string      $path       Cookie path (default: '/') 
 * @param   string      $prefix     Cookie name prefix 
 * @param   bool        $secure     Whether to only transfer cookies via SSL 
 * @param   bool        $httponly   Whether to only makes the cookie accessible via HTTP (no javascript) 
 * @return  void 
 */ 
 
/* public function set_cookie($name, $value = '', $expire = 0, $domain = '', $path = '/', $prefix = '', $secure = NULL, $httponly = NULL)
{ 
    if (is_array($name)) 
    { 
        // always leave 'name' in last place, as the loop will break otherwise, due to $$item 
        foreach (array('value', 'expire', 'domain', 'path', 'prefix', 'secure', 'httponly', 'name') as $item) 
        { 
            if (isset($name[$item])) 
            { 
                $$item = $name[$item]; 
            } 
        } 
    } 

    if ($prefix === '' && config_item('cookie_prefix') !== '') 
    { 
        $prefix = config_item('cookie_prefix'); 
    } 

    if ($domain == '' && config_item('cookie_domain') != '') 
    { 
        $domain = config_item('cookie_domain'); 
    } 

    if ($path === '/' && config_item('cookie_path') !== '/') 
    { 
        $path = config_item('cookie_path'); 
    } 

    $secure = ($secure === NULL && config_item('cookie_secure') !== NULL) 
        ? (bool) config_item('cookie_secure') 
        : (bool) $secure; 

    $httponly = ($httponly === NULL && config_item('cookie_httponly') !== NULL) 
        ? (bool) config_item('cookie_httponly') 
        : (bool) $httponly; 

    if ( ! is_numeric($expire) OR $expire < 0) 
    { 
        $expire = 1; 
    } 
    else 
    { 
        $expire = ($expire > 0) ? time() + $expire : 0; 
    } 

    setcookie($prefix.$name, $value, $expire, $path, $domain, $secure, $httponly); 
} 
 */


// Функція для читання, виводу і підрахунку статистики
function counterUrl($p, $f){
	
	$url_c = ['p'=>$p, 'v'=>0, 'd' => date('Y-m-d'), 't' => date('H:i:s')];
	
	// Встановлюємо і перевіряємо cookie
    $cookie_name = $url_c['p'];
    $cookie_value = 1;
    setcookie($cookie_name, $cookie_value, strtotime('tomorrow - 1 second'), "/"); // cookie працюватиме до 23:59:59

	// Якщо файл статистики існує, то читаємо дані з нього у масив
	$array_c = file_exists($f) ? json_decode(file_get_contents($f), true) :[];

	// Якщо масив $array_c існує, то обходимо його, знаходимо поточний url, і збільшуємо його лічильник
	if(is_array($array_c)){
	$nr = count($array_c);
		for($i=0; $i<$nr; $i++){
			if($array_c[$i]['p'] == $url_c['p']) {
			// Зберігаємо лічильник поточного url та видаляємо цей елемент з масиву
			$url_c['v'] = $array_c[$i]['v'];
			unset($array_c[$i]);
			$array_c = array_values($array_c);
			break;
			}
		}
	}

    // Збільшуємо лічильник і зберігаємо дані у json файлі (з показом помилки при невдачі)
    if(!isset($_COOKIE[$cookie_name])) {
        $url_c['v']++;
    } else {
        $url_c['v'] = $url_c['v'];
    }
	
	$array_c[] = $url_c;
	if(!file_put_contents($f, json_encode($array_c))) echo 'Unable to save data in: '. $f;
	return $url_c;
}


// Виклик функції для збереження адреси та кількості візитів сторінки (без імені домену)
$url = $_SERVER['REQUEST_URI'];
try {
    if (file_exists($dir_statistica)) {
        $count_data = counterUrl($url, $statistica);
        $count_data = 'Кількість переглядів сторінки - ' . $count_data['v'];
    } else {
        $count_data = "";
    }
} catch (Exception $e) {
    $count_data = $e->getMessage();
}

echo $count_data;
?>